{$apptype console}
{$q+,r+,n+,o+}

uses testlib, SysUtils;

const max = 10000000; { 10^7 }

type int = longint;
     real = int64;
     tpoint = array[1..2] of real;

var p1, p2 : tpoint;
    n, i, j, an, ou : int;
    l, r : array[1..2000] of tpoint;

    comment : string;

function sor(p0, p1, p2 : tpoint) : int;
var r : real;
begin
   r:=(p1[1] - p0[1])*(p2[2] - p0[2]) - (p2[1] - p0[1])*(p1[2] - p0[2]);
   if r=0 then sor:=0 else
      if r < 0 then sor:=-1 else sor:=1;
end;

procedure read_point(var x : tpoint; var s : instream);
begin
   x[1]:=s.readlongint;
   x[2]:=s.readlongint;

   if (abs(x[1]) > max) or (abs(x[2]) > max) then quit(_pe, comment);
end;

begin
   n:=inf.readlongint;

{   if an <> ou then quit(_wa, comment);}

   an:=0;
   ou:=0;

   for i:=1 to n do begin
      read_point(l[i], inf);
      read_point(r[i], inf);
   end;


   read_point(p1, ans);
   read_point(p2, ans);

   for i:=1 to n do
      if sor(p1, p2, l[i])*sor(p1, p2, r[i]) <= 0 then inc(an);


   read_point(p1, ouf);
   read_point(p2, ouf);

   if abs(p1[1] - p2[1]) + abs(p1[2] - p2[2]) < 1 then quit(_pe, comment);
   

   for i:=1 to n do
      if sor(p1, p2, l[i])*sor(p1, p2, r[i]) <= 0 then inc(ou);

   comment:='   N = ' + inttostr(n) + ', ans = ' + inttostr(an);
  
   if ou<an then quit(_WA,'Solution is not optimal:'+comment+'  found = '+inttostr(ou));
   if ou>an then quit(_Fail,'BOTVA :'+comment+'  found = '+inttostr(ou));

   quit(_ok, comment);
end.
